{% if groups['postgres'] | length > 1 %}
# Disable all components except PostgreSQL, Patroni, PgBouncer and Consul
roles ['patroni_role', 'pgbouncer_role']

# Patroni uses one extra slot per node when initiating the replication
patroni['postgresql']['max_replication_slots'] = {{ (((groups['postgres'] | length) * 2) * (geo_replication_slot_modifier | int)) }}
patroni['postgresql']['max_wal_senders'] = {{ (((groups['postgres'] | length) * 2) * (geo_replication_slot_modifier | int)) + 1 }}

patroni['remove_data_directory_on_rewind_failure'] = {{ patroni_remove_data_directory_on_rewind_failure | lower }}
patroni['remove_data_directory_on_diverged_timelines'] = {{ patroni_remove_data_directory_on_diverged_timelines | lower }}

postgresql['shared_preload_libraries'] = 'pg_stat_statements'

{% if patroni_password is defined %}
patroni['username'] = 'patroni-api'
patroni['password'] = '{{ patroni_password }}'
{% endif %}

# PgBouncer config (Database Load Balancing)
pgbouncer['databases'] = {
  gitlabhq_production: {
    host: "127.0.0.1",
    user: "pgbouncer",
    password: "{{ (pgbouncer_password + 'pgbouncer') | md5 }}"
  }
}

{% else %}
roles ['postgres_role']
{% endif %}

{% if postgres_version is defined %}
postgresql['version'] = {{ postgres_version }}
{% endif %}

# PostgreSQL configuration
postgresql['listen_address'] = '0.0.0.0'

postgresql['sql_user_password'] = "{{ (postgres_password + 'gitlab') | md5 }}"
{% if 'pgbouncer' in groups or groups['postgres'] | length > 1 %}
postgresql['pgbouncer_user_password'] = "{{ (pgbouncer_password + 'pgbouncer') | md5 }}"
{% endif %}

postgresql['trust_auth_cidr_addresses'] = {{ postgres_trust_auth_cidr_blocks }}
postgresql['md5_auth_cidr_addresses'] = {{ postgres_md5_auth_cidr_blocks }}

gitlab_rails['auto_migrate'] = false

{% if 'consul' in groups %}
# Consul Agent (Monitoring Auto Discovery)
consul['enable'] = true
consul['configuration'] = {
  bind_addr: '{{ ansible_default_ipv4.address }}',
  retry_join: %w({{ (consul_int_addrs | join(' ')) }})
}
consul['monitoring_service_discovery'] = true

# Consul Agent (Postgres HA)
{% if groups['postgres'] | length > 1 %}
consul['services'] = %w(postgresql)
{% endif %}

{% endif %}

# Monitoring
postgres_exporter['listen_address'] = '0.0.0.0:9187'
node_exporter['listen_address'] = '0.0.0.0:9100'

geo_confs = Dir.glob(File.join("/etc/gitlab/", "gitlab.geo.*.rb"))
geo_confs.each { |conf|
  from_file conf
}

custom_confs = Dir.glob(File.join("/etc/gitlab/", "gitlab.postgres.*.rb"))
custom_confs.each { |conf|
  from_file conf
}
